/***********************************************************************

        Pinc Dictionary Loader

Author: Rod Crawford

Date: 15/11/89
Mods:  5/ 4/90 Rod Added Support For Small Model
             by having different scanfs for different
             model sizes
      12/ 4/90 Rod Added OS9 Support

This file contains the functions for loading a dictionary file
of a given name from disk.


************************************************************************/

#include "cmodel.h"
#include "pinc.h"
#include "vmsize.h"
#include "strsizes.h"


/**************************  external data *******************************/


#if IMPLEMENTATION == MicrosoftC
    extern unsigned char huge ram[ RAM_TOP ];
#else
#if IMPLEMENTATION == OS9
    extern remote unsigned char ram[ RAM_TOP ];
#else
    extern unsigned char ram[ RAM_TOP ];
#endif
#endif


extern unsigned CELL dp, latest, voc_link;
extern struct from_fileblock {
     char filename[ FROM_FILENAME_LENGTH ];
     int page_number, line_number, line_in_page_number,
         last_page_required;
     FILE *stream;
       };

extern struct from_fileblock output;

/**************************  Function Prototypes  **********************/

#ifdef KNR
int load_dictionary();
#else
int load_dictionary(char *filename);
#endif


/************************  load_dictionary  ****************************

Desc: Searches for tile of the given name.
      If found:
         Loads Forth Registers with the values when the system was saved.
         Loads ram with the contents of the file  whose filename is
         supplied.
         returns true.
     else
        return false

In:  filename  name of file to be loaded.

Rets: True is file exhisted, else False.

*************************************************************************/

int load_dictionary( filename )
char filename[ LOAD_FILENAME_LENGTH ];
{
    FILE *load_file;
#if IMPLEMENTATION == OS9
    if(( load_file = fopen( filename, "r" )) == NULL ) {
#else
    if(( load_file = fopen( filename, "rb" )) == NULL ) {
#endif
       fprintf( output.stream, "No Dictionary File %s\n", filename );
       return( 0 );
    } else {
        unsigned CELL header_bytes_read, bytes_read;
        char header[ DICTIONARY_FILE_HEADER_LENGTH ];

        header_bytes_read = fread( header, sizeof( char ),
                                      DICTIONARY_FILE_HEADER_LENGTH,
                          load_file );
#ifdef CELL_IS_LONG_LONG
        sscanf( header, "%llx %llx %llx", &dp, &latest, &voc_link );
#else
#ifdef CELL_IS_LONG
        sscanf( header, "%lx %lx %lx", &dp, &latest, &voc_link );
#else
        sscanf( header, "%x %x %x", &dp, &latest, &voc_link );
#endif
#endif
        bytes_read = fread( ram, sizeof( CELL ),
                               dp/sizeof( CELL ) + dp%sizeof( CELL ),
                               load_file );
/*      fprintf( output.stream, "%ld bytes read from file %s\n",
                   header_bytes_read+bytes_read, filename ); */
        return( 1 );
   }

}
