/************************************************************************

          Pinc Startup Vector, User Variable and
          Vocabulary Table Header File

Author: Rod Crawford

Date: 14/11/89


This file describes the Pinc Startup Vectors, User area, Current and
Context Tables and were the dictionary
starts above it. The first two cells of ram are defined to be the
cold and warm startup addresses of Pinc. These should be set to
the CFAs of the words COLD and WARM. Alternatively the user can
set them to point to their own appplication. If their contents are
zero then Pinc knows it has not had the secondary level of code
compiled on top of it. This is useful for the error handler, which will
either jump through warm if full Pinc is running or just return after
printing the error in CWeed Forth.

NOTE: It is important that the dictionarys start address is greater than
      the ordinal value of the last Pinc Opcode. This property is used
      by Pincs inner interpreter to determine whether it is dealing
      with either a secodary or a primitive.


***********************************************************************/

#define COLD_VECTOR         ((CELL_SIZE) * 0)
#define WARM_VECTOR         ((CELL_SIZE) * 1)
#define SIGNAL_VECTOR       ((CELL_SIZE) * 2)
// rfu
#define USER_BASE           ((CELL_SIZE) * 4)


#define WIDTH         USER_BASE +   ((CELL_SIZE) * 1) // 4
#define TO_IN         USER_BASE +   ((CELL_SIZE) * 2) // 8
#define OUT           USER_BASE +  ((CELL_SIZE) * 3)
#define SPAN          USER_BASE +  ((CELL_SIZE) * 4)
#define HLD           USER_BASE +  ((CELL_SIZE) * 5)
#define BASE          USER_BASE +  ((CELL_SIZE) * 6)
#define DPL           USER_BASE +  ((CELL_SIZE) * 7)
#define HASH_TIB      USER_BASE +  ((CELL_SIZE) * 8)
#define HASH_L        USER_BASE +  ((CELL_SIZE) * 9)
#define TAB_WIDTH     USER_BASE +  ((CELL_SIZE) * 10)
#define HASH_D        USER_BASE +  ((CELL_SIZE) * 11)
#define LINE_NUMBER   USER_BASE +  ((CELL_SIZE) * 12)
#define PAGE_NUMBER   USER_BASE +  ((CELL_SIZE) * 13)
#define R0            USER_BASE +  ((CELL_SIZE) * 14)
#define S0            USER_BASE +  ((CELL_SIZE) * 15)
#define SYMBOL_TABLE  USER_BASE +  ((CELL_SIZE) * 16)
#define WORD_BUFF     USER_BASE +  ((CELL_SIZE) * 17)
#define PAD           USER_BASE + ((CELL_SIZE) * 25)
#define TIB           USER_BASE + ((CELL_SIZE) * 75) // 260
#define INIT_FENCE    USER_BASE + ((CELL_SIZE) * 129 ) // 516
#define INIT_DP       USER_BASE + ((CELL_SIZE) * 130) // 520
#define INIT_VOC_LINK USER_BASE + ((CELL_SIZE) * 131) // 524
#define ROOT_VOC      USER_BASE + ((CELL_SIZE) * 132) // 528
#define CURRENT_AREA  USER_BASE + ((CELL_SIZE) * 133) // 532
#define CONTEXT_AREA  USER_BASE + ((CELL_SIZE) * 134) // 536
#define COMPILE_STATE USER_BASE + ((CELL_SIZE) * 135) // 540
#define EMPTY         USER_BASE + ((CELL_SIZE) * 136) // 544

#define DICTIONARY_START USER_BASE + ((CELL_SIZE) * 150) //  600
