#makes main


#Fidl Compiler
#
# The Fidl Compiler does not depend on any other files.
# It generates the following header files
#     ENUM.H, PROTO.H, EXTPROTO.H, PRIM.H, EXEC.H
# Thus any file which imports one or more of these
# headers is dependant upon the Fidl compiler and
# the Fidl.src file.


fidl.obj: fidl.c
	CL /AS /c fidl.c

fidl.exe:   fidl.obj
	CL /AS /Fefidl.exe fidl.obj;


prim.h: fidl.src fidl.exe
	fidl.exe fidl.src


casecon.obj:	  casecon.c
	CL /AS /c casecon.c


io.obj:   io.c pinc.h cmodel.h vmsize.h lowram.h strsizes.h
	CL /AS /c io.c


headtrav.obj:	  headtrav.c pinc.h cmodel.h vmsize.h nfmasks.h enum.h
	CL /AS /c headtrav.c


threads.obj:	  threads.c pinc.h vocs.h cmodel.h lowram.h misc.h\
	     vmsize.h nfmasks.h
	CL /AS /c threads.c


prim.obj: prim.c pinc.h misc.h cmodel.h vmsize.h lowram.h vocs.h\
	  strsizes.h struct.h nfmasks.h prim.h proto.h os.h enum.h
	CL /AS /c prim.c


cwprim.obj:	  prim.c pinc.h misc.h cmodel.h vmsize.h lowram.h vocs.h\
	  strsizes.h struct.h nfmasks.h prim.h proto.h os.h
	CL /AS /DCWEED /c /Focwprim.obj prim.c


error.obj:	  error.c extproto.h pinc.h cmodel.h\
          lowram.h strsizes.h fname.h vmsize.h
	CL /AS /c error.c


stacks.obj:	  stacks.c cmodel.h vmsize.h misc.h
	CL /AS /c stacks.c


inner.obj:	  inner.c pinc.h cmodel.h vmsize.h prim.h misc.h enum.h
	CL /AS /c inner.c


cwinner.obj:	  inner.c pinc.h cmodel.h vmsize.h prim.h enum.h
	CL /AS /DCWEED /c /Focwinner.obj inner.c


carve.obj:	  carve.c cmodel.h dicmanip.c vocs.h lowram.h nfmasks.h vmsize.h\
	   prim.h misc.h
	CL /AS /c carve.c


dicmanip.obj:	  dicmanip.c pinc.h cmodel.h vmsize.h
	CL /AS /c dicmanip.c


dicload.obj:	  dicload.c pinc.h cmodel.h vmsize.h strsizes.h
	CL /AS /c dicload.c


n2str.obj:	  n2str.c cmodel.h vmsize.h lowram.h
	CL /AS /c n2str.c


str2n.obj:	  str2n.c cmodel.h vmsize.h lowram.h
	CL /AS /c str2n.c


cweed.obj:	  cweed.c pinc.h cmodel.h lowram.h nfmasks.h vmsize.h
	CL /AS /c cweed.c


main.obj: main.c extproto.h pinc.h cmodel.h lowram.h vmsize.h fname.h enum.h
	CL /AS /c main.c


cwforth.obj:	  main.c extproto.h pinc.h cmodel.h lowram.h vmsize.h
	CL /AS /DCWEED /c /Focwforth.obj main.c


cweed.exe:  cwforth.obj threads.obj cweed.obj cwprim.obj stacks.obj\
	   cwinner.obj carve.obj dicmanip.obj casecon.obj\
	   dicload.obj headtrav.obj n2str.obj str2n.obj error.obj io.obj
	CL /AS /Fecweed.exe cwforth threads cweed cwprim stacks\
	 cwinner carve dicmanip casecon dicload \
	 headtrav n2str str2n error io


pinc.exe:   cweed.exe main.obj threads.obj prim.obj stacks.obj\
	    inner.obj carve.obj dicmanip.obj casecon.obj\
	    dicload.obj headtrav.obj n2str.obj str2n.obj error.obj io.obj
	CL /AS /Fepinc.exe main threads prim stacks \
	 inner carve dicmanip casecon\
	 dicload headtrav n2str str2n error io


lexicon:	prim.h misc.h cscape
	cweed
