#makes main


#Fidl Compiler
#
# The Fidl Compiler does not depend on any other files.
# It generates the following header files
#     ENUM.H, PROTO.H, EXTPROTO.H, PRIM.H, EXEC.H
# Thus any file which imports one or more of these
# headers is dependant upon the Fidl compiler and
# the Fidl.src file.

all:	pinc cweed fidl boot.dic

fidl.r: fidl.c
	cc -r fidl.c

fidl:	fidl.r
	cc fidl.r;


prim.h:	fidl.src fidl
	fidl fidl.src


casecon.r:	casecon.c
	cc -r casecon.c


io.r:	io.c pinc.h cmodel.h vmsize.h lowram.h strsizes.h
	cc -r io.c




headtrav.r:	headtrav.c pinc.h cmodel.h vmsize.h nfmasks.h enum.h
	cc -r headtrav.c


threads.r:	threads.c pinc.h vocs.h cmodel.h lowram.h misc.h\
	     vmsize.h nfmasks.h
	cc -r threads.c


prim.r: prim.c pinc.h misc.h cmodel.h vmsize.h lowram.h vocs.h\
	  strsizes.h struct.h nfmasks.h prim.h proto.h os.h enum.h
	cc -r prim.c


cwprim.r:	prim.c pinc.h misc.h cmodel.h vmsize.h lowram.h vocs.h\
	  strsizes.h struct.h nfmasks.h prim.h proto.h os.h enum.h
	del cwprim.c
	copy prim.c cwprim.c
	cc -DCWEED -r cwprim.c


error.r:	error.c extproto.h pinc.h cmodel.h\
          lowram.h strsizes.h fname.h vmsize.h
	cc -r error.c


stacks.r:	stacks.c cmodel.h vmsize.h misc.h
	cc -r stacks.c


inner.r:	inner.c pinc.h cmodel.h vmsize.h prim.h misc.h enum.h
	cc -r inner.c


cwinner.r:	inner.c pinc.h cmodel.h vmsize.h prim.h misc.h enum.h
	del cwinner.c
	copy inner.c cwinner.c
	cc -DCWEED -r cwinner.c


carve.r:	carve.c cmodel.h dicmanip.c vocs.h lowram.h nfmasks.h vmsize.h\
	   prim.h misc.h
	cc -r carve.c


dicmanip.r:	dicmanip.c pinc.h cmodel.h vmsize.h
	cc -r dicmanip.c


dicload.r:	dicload.c pinc.h cmodel.h vmsize.h strsizes.h
	cc -r dicload.c


n2str.r:	n2str.c cmodel.h vmsize.h lowram.h
	cc -r n2str.c


str2n.r:	str2n.c cmodel.h vmsize.h lowram.h
	cc -r str2n.c


cweed.r:	cweed.c pinc.h cmodel.h lowram.h nfmasks.h vmsize.h
	cc -r cweed.c


main.r: main.c prim.h pinc.h cmodel.h lowram.h vmsize.h fname.h enum.h
	cc -r main.c


cwforth.r:	main.c prim.h pinc.h cmodel.h lowram.h vmsize.h
	del cwforth.c
	copy main.c cwforth.c
	cc -DCWEED -r cwforth.c


cweed:	cwforth.r threads.r cweed.r cwprim.r stacks.r\
	   cwinner.r carve.r dicmanip.r casecon.r\
	   dicload.r headtrav.r n2str.r str2n.r error.r io.r
	cc -f=cweed cwforth.r threads.r cweed.r cwprim.r stacks.r \
	 cwinner.r carve.r dicmanip.r casecon.r\
	 dicload.r headtrav.r n2str.r str2n.r error.r io.r


pinc:	cweed main.r threads.r prim.r stacks.r\
	    inner.r carve.r dicmanip.r casecon.r\
	    dicload.r headtrav.r n2str.r str2n.r error.r io.r
	cc -f=pinc main.r threads.r prim.r stacks.r \
	 inner.r carve.r dicmanip.r casecon.r\
	 dicload.r headtrav.r n2str.r str2n.r error.r io.r


lexicon:	prim.h misc.h cscape
	cweed
