/************************************************************************

          Pinc Name Field Masks

Author: Rod Crawford

Date: 14/11/89

This file defines the bit patterns associated with the count byte of the
Name Field of a Pinc defintion.
The count byte is distinguished as being at the start of the name string
by the fact that its top bit is set (bit7).
If the next bit is set (bit6) then the word is defined to be immediate.
If the next bit is set (bit5) then the word has been smudged.
To Enable Fast thread table searches the Inverse of the
Immediate and nfa masks is included.

**************************************************************************/


#define NFA_MASK       128
#define IMMEDIATE_MASK  64
#define SMUDGE_MASK     32
#define COUNT_BYTE_MASK ~(NFA_MASK | IMMEDIATE_MASK)
