/*************************************************************************

            Pinc Signal Handler

Author: Rod Crawford 

Date: 8/3/90

This file contains the set of functions which handle signals
from external events
This file is Unix Specific.

**************************************************************************/

#include <stdio.h>
#include <signal.h>
#include <setjmp.h>
#include "cmodel.h"
#include "lowram.h"
#include "vmsize.h"

/**************************  external data  *******************************/

extern jmp_buf environment;
extern unsigned CELL sp, rp, dp, ip, latest, voc_link;
extern unsigned char ram[ RAM_TOP ];



/**************************  external functions  *************************/

extern void set_cooked_io();
#ifdef CHECK_STACKS
extern void push_data();
#endif
extern unsigned CELL pop_data();
extern void inner_interpreter();
extern void fetch();



/*************************** function protoypes  ************************/

void init_signals();
void program_breakout();





/***************************  init_signals  *******************************

Desc: Traps off the require signals to the Pinc Signal Handler.

***************************************************************************/

void init_signals()
{
    signal( SIGINT, program_breakout );
}



/***************************  program_breakout  ***************************

Desc: This function is called when the user wishes to break out of
       Pinc. Before it exits via the longjmp, it restores cooked_io,
      in case we were in raw mode

*************************************************************************/

void program_breakout()
{
    set_cooked_io();
        sp = (CELL) -1;
        rp = (CELL) -1;
        push_data( (CELL) SIGNAL_VECTOR );
        fetch();
        ip = pop_data();
        inner_interpreter();

  }
