/****************************************************************

            Pinc Virtual Machine Memory and Stack Sizes

Author: Rod Crawford

Date: 14/11/89

Mods: 5/4/90 Rod Defined Typical Sizes For Each Implementation

Describes the sizes of the stacks and memory of the
Pinc Virtual Machine.

*********************************************************************/

#if IMPLEMENTATION == SUN

  #define RAM_TOP  0x20000
  #define DATA_STACK_TOP 0x100
  #define RETURN_STACK_TOP 0x100
  #define FROM_FILE_STACK_LENGTH 10

#else
#if IMPLEMENTATION ==  MicrosoftC

  #ifdef CELL_IS_LONG
  #define RAM_TOP  0x30000
  #define DATA_STACK_TOP 0x100
  #define RETURN_STACK_TOP 0x100
  #define FROM_FILE_STACK_LENGTH 10
  #else
  #define RAM_TOP  0x8000
  #define DATA_STACK_TOP 0x100
  #define RETURN_STACK_TOP 0x100
  #define FROM_FILE_STACK_LENGTH 10
  #endif

#else
#if IMPLEMENTATION == OS9

  #define RAM_TOP  0x20000
  #define DATA_STACK_TOP 0x100
  #define RETURN_STACK_TOP 0x100
  #define FROM_FILE_STACK_LENGTH 10

#else
#if IMPLEMENTATION == TurboC

  #define RAM_TOP  0x8000
  #define DATA_STACK_TOP 0x100
  #define RETURN_STACK_TOP 0x100
  #define FROM_FILE_STACK_LENGTH 10

#else
#if IMPLEMENTATION == Linux

  #define RAM_TOP  0x20000
  #define DATA_STACK_TOP 0x100
  #define RETURN_STACK_TOP 0x100
  #define FROM_FILE_STACK_LENGTH 10

#else
#if IMPLEMENTATION == Linux64

//  #warning "=== Linux64 ==="
  #define RAM_TOP  0x20000
  #define DATA_STACK_TOP 0x100
  #define RETURN_STACK_TOP 0x100
  #define FROM_FILE_STACK_LENGTH 10

#else
#if IMPLEMENTATION == MinGW64

//  #warning "=== MinGW64 ==="
  #define RAM_TOP  0x00100000
  #define DATA_STACK_TOP 0x200
  #define RETURN_STACK_TOP 0x200
  #define FROM_FILE_STACK_LENGTH 10

#else
  #error No Implementation Specified
#endif
#endif
#endif
#endif
#endif
#endif
#endif
